import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay"
import "Project1000.Patch"

characters={}

string_lang={
	["add"]		={["EN"]="add",["DE"]="Hinzuf\195\188gen",["FR"]="[add]", },
	["remove"]	={["EN"]="remove",["DE"]="Entfernen",["FR"]="[remove]", },
	["progress"]	={["EN"]="Progress",["DE"]="Fortschritt",["FR"]="[progress]", },
	["written"]	={	["EN"]=", by Mandraval, based on code by Thurallor",
				["DE"]=", von Mandraval, auf dem Code von Thurallor basierend",
				["FR"]="[written]", },
}

function print(text) 
	if(text~=nil) then 
		Turbine.Shell.WriteLine("<rgb=#00FF80>1k:</rgb> "..text or "") 
	end
end

--**v Detect Game Language v**
-- Legend: 0 = invalid / 2 = English / 268435457 = EnglishGB / 268435459 = Francais / 268435460 = Deutsch / 268435463 = Russian
GLocale = Turbine.Engine.GetLanguage();
if GLocale == 268435459 then cur_lang = "FR";
elseif GLocale == 268435460 then cur_lang = "DE"; 
else cur_lang = "EN";
end
--**^ this code fragment is from Titansbars
player = Turbine.Gameplay.LocalPlayer.GetInstance()
pname = player:GetName()
local width = 260;


p1000settings=Project1000.PatchDataLoad(Turbine.DataScope.Server,"p1000")
if type(p1000settings)~="table" then
	p1000settings={}
end
characters = p1000settings["characters"]
if type(characters) ~= "table" then
	characters={}
end
posx = p1000settings["posx"]
if posx==nil then
	posx=math.floor((Turbine.UI.Display.GetWidth() - width) / 2)
end
posy = p1000settings["posy"]
if posy==nil then
	posy=0
end

pane = Turbine.UI.Window();
pane:SetVisible(true);
pane:SetZOrder(2147483647);
pane.MouseEnter = function()
    pane:SetBackColor(Turbine.UI.Color(0.25, 1, 1, 1));
    p1000Button:SetVisible(true);
end
pane.MouseLeave = function()
    pane:SetBackColor(nil);
    p1000Button:SetVisible(false);
end

TitelCaption = Turbine.UI.Label();
TitelCaption:SetParent(pane);
TitelCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
TitelCaption:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
TitelCaption:SetForeColor(Turbine.UI.Color(1.0, 0.75, 0.0));
TitelCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
TitelCaption:SetOutlineColor(Turbine.UI.Color(0, 0, 0));
TitelCaption:SetText(string_lang["progress"][cur_lang]);
TitelCaption:SetMouseVisible(false);

p1000Progress = Turbine.UI.Control();
p1000Progress:SetParent(pane);
p1000Progress:SetSize(width,24);
p1000Progress:SetBackColor(Turbine.UI.Color(0.25,1, 0, 0));
p1000Progress:SetBlendMode(4);

p1000ProgressOverlay = Turbine.UI.Control();
p1000ProgressOverlay:SetParent(p1000Progress);
p1000ProgressOverlay:SetSize(width,24);
p1000ProgressOverlay:SetPosition(0,0);
p1000ProgressOverlay:SetBackColor(Turbine.UI.Color(0.25,0, 1, 0));
p1000ProgressOverlay:SetBlendMode(4);
p1000ProgressOverlay:SetMouseVisible(false);

function do_update()
	maxlevel=0
	levelsum=0
	charsum=0
	for char in pairs(characters) do
--		print (char.." "..characters[char])
		level=characters[char]
		if(maxlevel<level) then
			maxlevel=level
		end
		levelsum=levelsum+level
		charsum=charsum+1
	end
	if(charsum>0) then
		p1000Status:SetText(string.format("%d/%d (%5.2f%%)",levelsum,maxlevel*charsum,100.0*levelsum/(maxlevel*charsum)));
		p1000ProgressOverlay:SetWidth( width * (levelsum/(maxlevel*charsum)) );

	else
		p1000Status:SetText("??/?? (xx.xx%)");
		p1000ProgressOverlay:SetWidth(0);
	end
end
p1000Status = Turbine.UI.Label();
p1000Status:SetParent(pane);
p1000Status:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24);
p1000Status:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
p1000Status:SetForeColor(Turbine.UI.Color(1.0, 1.0, 1.0));
p1000Status:SetFontStyle(Turbine.UI.FontStyle.Outline);
p1000Status:SetOutlineColor(Turbine.UI.Color(0, 0, 0));
p1000Status:SetText("??/?? (xx.xx%)");
p1000Status:SetMouseVisible(false);
p1000Status.Update = function()
	if(characters[pname]~=nil) then
		if(characters[pname]~=player:GetLevel()) then
			characters[pname]=player:GetLevel()
			do_update()
		end
	end
end
p1000Status:SetWantsUpdates(true);

p1000Button = Turbine.UI.Lotro.Button();
p1000Button:SetParent(pane);
p1000Button:SetVisible(false);
p1000Button:SetFont(Turbine.UI.Lotro.Font.TrajanPro13);

print(pname)
if(characters[pname]~=nil) then
	p1000Button:SetText(string_lang["remove"][cur_lang]);
else
	p1000Button:SetText(string_lang["add"][cur_lang]);
end
p1000Button.Click = function()
	if(characters[pname]~=nil) then
		p1000Button:SetText(string_lang["add"][cur_lang]);
		characters[pname]=nil
	else
		p1000Button:SetText(string_lang["remove"][cur_lang]);
		characters[pname]=player:GetLevel()
	end
	do_update()
end

local width = 260;
local top = 0;

local h = 20;
TitelCaption:SetSize(width, h);
TitelCaption:SetPosition(0, top);
top = top + h;

h = 26;
p1000Status:SetSize(width, h);
p1000Status:SetPosition(0, top);
p1000Progress:SetPosition(0,top);
top = top + h;

w, h = 100, 20;
p1000Button:SetSize(w, h);
p1000Button:SetPosition(math.floor((width - w) / 2), top);
top = top + h;

local height = top + 5;
pane:SetSize(width, height);
--pane:SetPosition(math.floor((Turbine.UI.Display.GetWidth() - width) / 2), 0);
pane:SetPosition(posx,posy);

do_update()


pane.MouseDown = function()
    pane.prevMouseX, pane.prevMouseY = Turbine.UI.Display.GetMouseX(), Turbine.UI.Display.GetMouseY();
    pane.dragging = true;
end

pane.MouseUp = function()
    pane.dragging = false;
end

pane.MouseMove = function()
    if (pane.dragging) then
        local x, y = Turbine.UI.Display.GetMouseX(), Turbine.UI.Display.GetMouseY();
        deltaX, deltaY = x - pane.prevMouseX, y - pane.prevMouseY;
        pane:SetPosition(pane:GetLeft() + deltaX, pane:GetTop() + deltaY);
        pane.prevMouseX, pane.prevMouseY = x, y;
	posx,posy=x,y
    end
end


function UnloadPlugin()
	local left, top = pane:GetPosition();
	p1000settings["posx"]=left
	p1000settings["posy"]=top
	p1000settings["characters"]=characters

	Project1000.PatchDataSave(Turbine.DataScope.Server,"p1000",p1000settings)
	
  	print("Project1000 "..Plugins["Project1000"]:GetVersion().." freigegeben. x:"..posx.." y:"..posy)
end

Plugins["Project1000"].Unload = function(self,sender,args)
	UnloadPlugin();
end

Turbine.Shell.WriteLine("Project1000 "..Plugins["Project1000"]:GetVersion()..", by Mandraval, based on code by Thurallor");
